﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class CarsBusinessLogic
    {
        public ObservableCollection<Car> GetCars()
        {
            ObservableCollection<Car> carList = new ObservableCollection<Car>();
            carList.Add(new Car("Dodge", "Ram", 22050, 27175, 35600, 20790, 22050, 27175));
            carList.Add(new Car("Ford", "Explorer", 27175,22050, 27175, 35600, 20790, 22050));
            carList.Add(new Car("BMW", "Z4", 35600,22050, 27175, 35600, 20790, 22050));
            carList.Add(new Car("Toyota", "Camry", 20790,22050, 27175, 35600, 20790, 22050));

            return carList;
        }
    }

    public class Car : INotifyPropertyChanged
    {
        string m_make;
        string m_model;
        decimal m_baseprice;
        decimal m_height;
        decimal m_width;
        decimal m_capacity;
        decimal m_weight;
        decimal m_age;


        public Car()
        {
        }

        public Car(string make, string model, decimal baseprice, decimal height, decimal width, decimal capacity, decimal weight, decimal age)
        {
            this.Make = make;
            this.Model = model;
            this.BasePrice = baseprice;
            this.Height = height;
            this.Width = width;
            this.Capacity = capacity;
            this.Weight = weight;
            this.Age = age;
           
        
        }

        public string Make
        {
            get { return m_make; }
            set
            {
                if (m_make != value)
                {
                    m_make = value;
                    OnPropertyChanged("Make");
                }
            }
        }

        public string Model
        {
            get { return m_model; }
            set
            {
                if (m_model != value)
                {
                    m_model = value;
                    OnPropertyChanged("Model");
                }
            }
        }

        public decimal BasePrice
        {
            get { return m_baseprice; }
            set
            {
                if (m_baseprice != value)
                {
                    m_baseprice = value;
                    OnPropertyChanged("BasePrice");
                }
            }
        }

        public decimal Height
        {
            get { return m_height; }
            set
            {
                if (m_height != value)
                {
                    m_height = value;
                    OnPropertyChanged("Height");
                }
            }
        }



        public decimal Width
        {
            get { return m_width; }
            set
            {
                if (m_width != value)
                {
                    m_width = value;
                    OnPropertyChanged("Width");
                }
            }
        }



        public decimal Capacity
        {
            get { return m_capacity; }
            set
            {
                if (m_capacity != value)
                {
                    m_capacity = value;
                    OnPropertyChanged("Capacity");
                }
            }
        }


        public decimal Weight
        {
            get { return m_weight; }
            set
            {
                if (m_weight != value)
                {
                    m_weight = value;
                    OnPropertyChanged("Weight");
                }
            }
        }


        public decimal Age
        {
            get { return m_age; }
            set
            {
                if (m_age != value)
                {
                    m_age = value;
                    OnPropertyChanged("Age");
                }
            }
        }

       

       

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

}